package org.bitbucket.bradleysmithllc.etlunit.feature.database.db;

import org.bitbucket.bradleysmithllc.etlunit.feature.database.DatabaseImplementation;
import org.bitbucket.bradleysmithllc.etlunit.feature.database.json.database.extract.ExtractRequest;
import org.bitbucket.bradleysmithllc.etlunit.io.file.DataFileSchema;

import java.util.List;

public interface Table extends JsonRepresentation {
	Schema getSchema();

	Catalog getCatalog();

	String getName();

	void addColumn(TableColumn timpl);

	boolean hasColumn(String columnName);

	TableColumn getColumn(String columnName);

	List<TableColumn> getTableColumns();

	List<String> getTableColumnNames();

	void resetPrimaryKeyColumns();

	void addPrimaryKeyColumn(TableColumn column);

	List<TableColumn> getPrimaryKeyColumns();

	void resetOrderColumns();

	void addOrderKeyColumn(TableColumn column);

	List<TableColumn> getOrderKeyColumns();

	DataFileSchema getDataFileSchema();

	void setDataFileSchema(DataFileSchema dataFileSchema);

	String getQualifiedName();

	boolean hasIdentityColumns();

	String createSQLInsert();

	/**
	 * Create sql for the given destination implementation.
	 * @param dbi
	 * @return
	 */
	String createSQLInsert(DatabaseImplementation dbi);

	String createSQLSelect();
	String createSQLSelect(DatabaseImplementation dbi);

	String createSQLSelect(DatabaseImplementation dbi, boolean ordered);
	String createSQLSelect(boolean ordered);

	Table createSubView(List<String> list, ExtractRequest.ColumnListMode listMode);

	void setSqlScriptSource(String sqlScriptSource);

	enum type {
		table,
		view,
		system_table,
		temp_table,
		synthetic,
		sql
	}

	type getType();

	String getDBLocalName();
}